#include "stdafx.h"
#include "NotifyWindowHandler.h"
#include "WindowScriptletPlugin.h"
#include "NotifyFrameWindow.h"
#include "ObserverTool.h"
#include "CommandHelper.h"
#include "HttpClient/httpclient.h"

namespace tipupdater
{
	NotifyWindowHandler* NotifyWindowHandler::m_notifyWindow = 0;

	BOOL NotifyWindowHandler::GetMoniterRect( RECT &source, RECT &monitorRect, DWORD dwFlag )
	{
		HMONITOR hMonitor = MonitorFromRect( &source, dwFlag );
		if( NULL == hMonitor )
			return FALSE;

		MONITORINFO pmi;
		pmi.cbSize = sizeof(MONITORINFO);
		if( FALSE == GetMonitorInfo( hMonitor, &pmi ) )
			return FALSE;

		monitorRect.bottom	= pmi.rcMonitor.bottom;
		monitorRect.left	= pmi.rcMonitor.left;
		monitorRect.top		= pmi.rcMonitor.top;
		monitorRect.right	= pmi.rcMonitor.right;

		return TRUE;
	}

	BOOL NotifyWindowHandler::GetPrimaryMoniterRect( RECT &monitorRect )
	{
		RECT rect; 
		return GetMoniterRect( rect, monitorRect, MONITOR_DEFAULTTOPRIMARY );
	}

	CPoint NotifyWindowHandler::GetCalculateWindowPosition( UINT taskbarType, int w, int h, RECT current, RECT taskbar )
	{
		CPoint pos;

		switch( taskbarType )
		{
		case ABE_LEFT:
			pos.x = current.right - w;
			pos.y = current.bottom - h;
			break;

		case ABE_RIGHT:
			pos.x = taskbar.left - w;
			pos.y = taskbar.bottom - h;
			break;

		case ABE_BOTTOM:
			pos.x = taskbar.right - w;
			pos.y = taskbar.top - h;
			break;

		case ABE_TOP:
			pos.x = taskbar.right - w;
			pos.y = taskbar.bottom;
		}

		return pos;
	}

	BOOL NotifyWindowHandler::CreateNotifyWindow(UpdaterNotifyWindowItem item, UpdaterDocument *doc)
	{
		CString layout_name;

		m_DataContext = new SimpleMapDataContext;
		if( NULL == m_DataContext )
			return FALSE;

		item.BindDataContext( layout_name, m_DataContext, doc );
		m_rootwindow = CWindowScriptletPlugin::CreateBaseWindow(Application::LoadLayoutNode(layout_name), m_DataContext);

		//
		// BTS-117 101022 Ȳ
		// , ˻  ˸  ޽ڽ .
		//  ̽ ƴѰ쿡 ˸ ޸ ŸӾƿ ޽ڽ .
		//
		// , ˻  쿡  쿡 ٽ ̹ 
		// , ˻ڸ 纯 .
		// ̶   yes, no  nclicks ȣ༭ 踦 .
		//
		if (layout_name == _T("tip_notifywindow_startpage"))
		{
			::ShowWindow(m_rootwindow->m_hWndBase, SW_HIDE);
			CString strStartPageUrl = CoreValueObserverTool::StartPageObserver::sm_strStartPageUrl;
			int nResult = MessageBox::CallStartPage(strStartPageUrl, NULL);
			if (nResult == IDYES)
			{
				tipbase::GenericHTTPClient httpNClicks;
				httpNClicks.SetNclicks();
				httpNClicks.Request(NULL, _T("http://cc.naver.com/cc?a=upd.homeclose&u=about%3Ablank&nsc=tools.app&m=0"));
			}
			else
			{
				CommandHelper::ExecuteCommand(_T("KeepStartPageCommand"));
				tipbase::GenericHTTPClient httpNClicks;
				httpNClicks.SetNclicks();
				httpNClicks.Request(NULL, _T("http://cc.naver.com/cc?a=upd.homechg&u=about%3Ablank&nsc=tools.app&m=0"));
			}
		} 
		else if (layout_name == _T("tip_notifywindow_defaultsearch"))
		{
			::ShowWindow(m_rootwindow->m_hWndBase, SW_HIDE);
			CString strDefaultSearchName = CoreValueObserverTool::DefaultSearchObserver::sm_strName;
			int nResult = MessageBox::CallDefaultSearch(strDefaultSearchName, NULL);
			if (nResult == IDYES)
			{
				tipbase::GenericHTTPClient httpNClicks;
				httpNClicks.SetNclicks();
				httpNClicks.Request(NULL, _T("http://cc.naver.com/cc?a=upd.searchclose&u=about%3Ablank&nsc=tools.app&m=0"));
			}
			else
			{
				CommandHelper::ExecuteCommand(_T("KeepDefaultSearchCommand"));
				tipbase::GenericHTTPClient httpNClicks;
				httpNClicks.SetNclicks();
				httpNClicks.Request(NULL, _T("http://cc.naver.com/cc?a=upd.searchchg&u=about%3Ablank&nsc=tools.app&m=0"));
			}
		}
		else
		{
			if (m_rootwindow)
			{
				::ShowWindow(m_rootwindow->m_hWndBase, SW_SHOW);
				m_window = m_rootwindow->GetWindow();
				CRect rcWindow;
				m_window.GetWindowRect(&rcWindow);

				CNotifyFrameWindow *pWindow = dynamic_cast<CNotifyFrameWindow *>(m_rootwindow);
				pWindow->SetMessageHwnd(m_hWnd);
				pWindow->AutoDeleteDataContext();

				APPBARDATA abd;
				abd.cbSize = sizeof( APPBARDATA );
				abd.hWnd = ::GetDesktopWindow();

				if( TRUE == SHAppBarMessage( ABM_GETTASKBARPOS, &abd ) )
				{
					//		RECT rc_primary;
					RECT rc_current;
					//		GetPrimaryMoniterRect(rc_primary);
					GetMoniterRect(abd.rc, rc_current);

					m_Pos = GetCalculateWindowPosition( abd.uEdge, rcWindow.Width(), rcWindow.Height(), 
						rc_current, abd.rc );
				}
			}
		}



		return TRUE;
	}
}